<?
// diary by whatisid
// 2001.02.18 ϱ κ ߰ 
// 2001.03.11 mysql ƴ file  ۼ
// 2001.09.16 ȿ ϰ  

include("./class.FastTemplate.php");
include("./config.inc.php");

$maxsize=81920;
if ($enable_reply == "") $enable_reply = false;
else if (strcasecmp($enable_reply,"on")==0) $enable_reply = true;
else $enable_reply = false;
class DataType
{
	var $diarydate;
	var $writetime;
	var $content;
	var $ip;

function DataType($dd,$wt,$ct,$ia)
{
	$this->diarydate = $dd;
	$this->writetime = $wt;
	$this->content = $ct;
	$this->ip = $ia;	
}

function getRawData()
{
	$retval = $this->diarydate."|".$this->writetime."|".rawurlencode($this->content)."|".$this->ip;
	return $retval;
}
}

class ReplyDataType
{
	var $diarydate;
	var $writetime;
	var $writer;
	var $content;
	var $ip;
	var $cryptedpass;
	var $salt = "whatisid";

	function ReplyDataType($wdate,$wtime,$writerval,$contentval,$ipval,$userpass)
	{
		$this->diarydate = $wdate;
		$this->writetime = $wtime;
		$this->writer = $writerval;
		$this->content = $contentval;
		$this->ip = $ipval;
		$this->cryptedpass = $userpass;
	}

	function getRawData()
	{
		$retval = $this->diarydate."|".$this->writetime."|".rawurlencode($this->writer)."|".rawurlencode($this->content)."|".$this->ip."|";
		$retval.= $this->cryptedpass;
		return $retval;
	}

	function getIsSamePassword($userinputpass)
	{
		$c = crypt($userinputpass,$this->salt);
		if (trim($c) == trim($this->cryptedpass)) 
		{
			return true;
		}
		else 
		{
			return false;
		}
	}
	function setCryptedpass()
	{
		$this->cryptedpass = crypt($this->cryptedpass,$this->salt);
	}
}

function getFilename($filetype,$timestp,$create=true)
{
	if ($filetype == "diary")
	{
		$file_name = "./data/diary_".date("Ym",$timestp).".db";
	}
	else
	{
		$file_name = "./data/reply_".date("Ym",$timestp).".db";
	}
	if ($create)
	{
		if (!file_exists($file_name)) 
		{
			$cf = fopen($file_name,"w");
			fclose($cf);
		}
	}
	return $file_name;
}

function getTempFilename($filetype,$timestp,$create=true)
{
	if ($filetype == "diary")
	{
		$file_name = "./data/diary_".date("Ym",$timestp).".db.temp";
	}
	else
	{
		$file_name = "./data/reply_".date("Ym",$timestp).".db.temp";
	}
	if ($create)
	{
		if (!file_exists($file_name)) 
		{
			$cf = fopen($file_name,"w");
			fclose($cf);
		}
	}
	return $file_name;
}

function diary_fetch_object($str)
{
//	0=diarydate,1=writedate,2=content,3=ip
	$parse = explode("|",$str);
	$row = new DataType($parse[0],$parse[1],rawurldecode($parse[2]),$parse[3]);

	return $row;
}


function reply_fetch_object($str)
{
//	0=diarydate+sequence, 1=writedate, 2=name,3=content, 4=ip, 5=crypted pass with salt $diarypass
	$parse = explode("|",$str);
	$row = new ReplyDataType($parse[0],$parse[1],rawurldecode($parse[2]),rawurldecode($parse[3]),$parse[4],$parse[5]);
	
	return $row;
}

function updateOperation($key,$values,$filetype="diary")
{
	//global $file_name;
	global $maxsize;

	//   tempfile 
		$file_name = getFilename($filetype,$key);
		$temp_file_name = getTempFilename($filetype,$key,false);
        $fp = fopen($file_name,"r");
        $wfp = fopen($temp_file_name,"w");
        flock($fp,LOCK_SH);
        flock($wfp,LOCK_EX);
        while (!feof($fp))
        {
                $raw_data = fgets($fp,$maxsize);
                fputs($wfp,$raw_data);
        }
        flock($wfp,LOCK_UN);
        fclose($wfp);
        flock($fp,LOCK_UN);
        fclose($fp);

	// $key شϴ   $values  
	$result = false;
	$fp = fopen($temp_file_name,"r");
	$wfp = fopen($file_name,"w");
	flock($fp,LOCK_SH);
	flock($wfp,LOCK_EX);
	while (!feof($fp))
	{
		$raw_data = fgets($fp,$maxsize);
		$parse = explode("|",$raw_data);
		if ($parse[0] != $key)
		{
			 fputs($wfp,$raw_data);
		}
		else
		{
			fputs($wfp,$values);
			$result = true;
		}
	}
        flock($wfp,LOCK_UN);
        fclose($wfp);
        flock($fp,LOCK_UN);
        fclose($fp);
return $result;
}

function deleteOperation($key,$filetype="diary")
{
	//global $file_name;
	global $maxsize;

	//   tempfile 
		$file_name = getFilename($filetype,$key);
		$temp_file_name = getTempFilename($filetype,$key,false);
        $fp = fopen($file_name,"r");
        $wfp = fopen($temp_file_name,"w");
        flock($fp,LOCK_SH);
        flock($wfp,LOCK_EX);
        while (!feof($fp))
        {
                $raw_data = fgets($fp,$maxsize);
                fputs($wfp,$raw_data);
        }
        flock($wfp,LOCK_UN);
        fclose($wfp);
        flock($fp,LOCK_UN);
        fclose($fp);

	// $key شϴ    Ϸ 
	$result = false;
	$fp = fopen($temp_file_name,"r");
	$wfp = fopen($file_name,"w");
	flock($fp,LOCK_SH);
	flock($wfp,LOCK_EX);
	while (!feof($fp))
	{
		$raw_data = fgets($fp,$maxsize);
		$parse = explode("|",$raw_data);
		if ($parse[0] != $key)
		{
			 fputs($wfp,$raw_data);
		}
		else $result = true;
	}
        flock($wfp,LOCK_UN);
        fclose($wfp);
        flock($fp,LOCK_UN);
        fclose($fp);
return $result;
}

function selectOperation($from_key,$to_key,&$selected_rows,$filetype="diary")
{
	//global $file_name;
	global $maxsize;

	$while_key = $to_key;
	$count=0;
	while ($from_key<=$while_key)
	{
		$file_name = getFilename($filetype,$while_key);
		$fp = fopen($file_name,"r");
		while (!feof($fp))
		{
			$raw_data = fgets($fp,$maxsize);
			$parse = explode("|",$raw_data);
			if (($from_key<=$parse[0])&&($parse[0]<=$to_key))
			{
				$count++;
				$row[$count] = $raw_data;
			}
		}
		$while_key = mktime(0,0,0,date("m",$while_key)-1,1,date("Y",$while_key));
	}
	$selected_rows = $count;
	for ($i=1;$i<=$count;$i++)
	{
		$reverse_row[$count-$i+1] = $row[$i];
	}
	return $reverse_row;
}

function insertOperation($key,$values,$filetype="diary")
{
	global $file_name;
	global $maxsize;

	// write ϴ κ diarydate,writetime,content,ip
	//  file tempfile ̵
	$file_name = getFilename($filetype,$key);
	$temp_file_name = getTempFilename($filetype,$key,false);

	$fp = fopen($file_name,"r");
	$wfp = fopen($temp_file_name,"w");
	flock($fp,LOCK_SH);
	flock($wfp,LOCK_EX);
	while (!feof($fp))
	{
		$raw_data = fgets($fp,$maxsize);
		if (!feof($fp))
		{
			$constraint = explode("|",$raw_data);
			if ($constraint[0] == $key)
			{
			echo($constraint[0]." :  ȣ  ߺ ˴ϴ.   ٽ õϰų ش  ϱ⸦  ּ.");
			flock($wfp,LOCK_UN);
			flock($fp,LOCK_UN);
			fclose($wfp);
			fclose($fp);
			exit();
			}
			fputs($wfp,$raw_data);
		}
	}
	flock($wfp,LOCK_UN);
	fclose($wfp);
	flock($fp,LOCK_UN);
	fclose($fp);

	// tempfile $values   dbfile 
	$fp = fopen($temp_file_name,"r");
	$wfp = fopen($file_name,"w");
	flock($fp,LOCK_SH);
	flock($wfp,LOCK_EX);
	$not_inserted = true;
	$rows_count = 0;
	while (true)
	{
		$raw_data = fgets($fp,$maxsize);
		if (feof($fp)&&($raw_data=="")) break;
		$parse = explode("|",$raw_data);
		// $key   ö  data tempfile ϰ,     tempfile $value .
		if ($parse[0]>$key) 
		{
			fputs($wfp,$raw_data);
			$row_count++;
		}
		if (($parse[0]<$key)&&($not_inserted))
		{
			fputs($wfp,$values."\n");
			$not_inserted = false;
			$row_count++;
		}
		if (($parse[0]<$key)&&(!$not_inserted))
		{
			fputs($wfp,$raw_data);
			$row_count++;
		}
	}
	if ($not_inserted) fputs($wfp,$values."\n");
	flock($wfp,LOCK_UN);
	fclose($wfp);
	flock($fp,LOCK_UN);
	fclose($fp);
}

function goLocation($location) { 
	//echo("<meta http-equiv=\"refresh\" content=\"0;url=$location\">");
	header("Location: ".$location);
	exit();
}

function stringFilter($censorstr,$htmlallow=true) {
	$first = stripslashes(eregi_replace("<script>|</script>","&nbsp;",$censorstr));
	if (!$htmlallow) {
			$first = eregi_replace("<","&lt;",$first);
			$first = eregi_replace(">","&gt;",$first);
	}
//	if (trim($first)=="") $first = "";
	return nl2br(stripslashes(stripslashes($first)));
}

function dbFilter($censorstr) {
	return addslashes($censorstr);
}

function isYunChk($yearvalue) {
// 4   ̰ 100    ƴϰ 400   ̴.
// return 1 ̸ 
	$retval = 0;
	if (($yearvalue%4)==0) {
		$retval = 1;
		if (($yearvalue%100)==0) {
			$retval = 0;
			if (($yearvalue%400)==0) {
				$retval = 1;
			}
		}
	}

	return $retval;
}

$tpl = new FastTemplate("./tpl/");
$tpl->define(array(
	MAINTPL => "maintpl.tpl",
	EDITFORM => "editform.tpl",
	DELETEFORM => "deleteform.tpl",
	REPLYFORM => "replyform.tpl",
	REPLYDELETEFORM => "replydeleteform.tpl",
	VIEW => "view.tpl",
	VIEW_EDIT_LINK => "view_edit_link.tpl",
	VIEW_REPLY => "view_reply.tpl",
	VIEW_REPLY_ITEM => "view_reply_item.tpl",
	MONTH => "month.tpl",
	DAY_WITH_DATA => "day_with_data.tpl",
	DAY_WITHOUT_DATA => "day_without_data.tpl",
	WRITEFORM => "writeform.tpl"
	));

$tpl->assign(PHP_SELF,$PHP_SELF);
$nowtime = time();
if ($action=="replydeleteform")
{
	$tpl->assign(DIARYDATE,$deletekey);
	$tpl->parse(MAINCONTENT_HERE,"REPLYDELETEFORM");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);	
	exit();
}
if ($action=="replydelete")
{
	$result = selectOperation($deletekey,$deletekey,$reply_count,"reply");
	if ($reply_count > 0)
	{
		$row = reply_fetch_object($result[1]);
		if ($row->getIsSamePassword($passwordval)||$passwordval==$diarypass) 
		{
			deleteOperation($deletekey,"reply");
		}
		else
		{
			$tpl->assign(MAINCONTENT_HERE,"<p align=center>ȣ  ʽϴ-_-;;;");
			$tpl->parse(MAIN,"MAINTPL");
			$tpl->FastPrint(MAIN);
			exit();
		}
	}

	$y = date("Y",$deletekey);
	$m = date("m",$deletekey);
	$d = date("d",$deletekey);
	goLocation($PHP_SELF."?gYear=$y&gMonth=$m&gDay=$d");
}
if ($action=="replyform")
{
	$tpl->assign(DIARYDATE,$diarydate);
	$tpl->parse(MAINCONTENT_HERE,"REPLYFORM");
        $tpl->parse(MAIN,"MAINTPL");
        $tpl->FastPrint(MAIN);
        exit();
}
if ($action=="replywrite")
{
	// $reply  date+4ڸ sequence
	if ($userpass == "") 
	{
		echo("<script>alert('ȣ Ҷ ˴ϴ. ʼԴϴ.'); go.history(-1); </script>");
		return;
	}
	
	$sql = "INSERT ";
	$result = selectOperation($diarydate,$diarydate+86399,$num,"reply");
	$zero = "";
	$row = reply_fetch_object($result[$num]);
	
	if ($num !=0) 
	{
		$nextnum = $row->diarydate +1; 
	}
	else 
	{
		$nextnum = $diarydate;
	}

	if ($nextnum-$diarydate>10000)
	{
		echo("<script> alert(' ̻ ޼ ϴ.'); go.history(-1); </script>");
	}
	$writekey = $nextnum;
	$wtime = time();
	$ip = getenv("REMOTE_ADDR");
	$raw_data = new ReplyDataType($writekey,$wtime,$writerval,$contentval,$ip,$userpass);
	$raw_data->setCryptedpass();
        insertOperation($writekey,$raw_data->getRawData(),"reply");
	$y = date("Y",$writekey);
	$m = date("m",$writekey);
	$d = date("d",$writekey);
	goLocation($PHP_SELF."?gYear=$y&gMonth=$m&gDay=$d");

	exit();
}
if ($action=="editform")
{
	$sql = "SELECT * FROM diary WHERE diarydate=$diarydate";
	$result = selectOperation($diarydate,$diarydate,$num);
	if ($num>0)
	{
		$row = diary_fetch_object($result[1]);
		$tpl->assign(DIARYDATE,$diarydate);
		$tpl->assign(INIT_CONTENT,stripSlashes($row->content));
		$tpl->assign(EDIT_YEAR,date("Y",$row->diarydate));
		$tpl->assign(EDIT_MONTH, date("m",$row->diarydate));
		$tpl->assign(EDIT_DAY,date("d",$row->diarydate));
		$tpl->parse(MAINCONTENT_HERE,"EDITFORM");
	}
	else
	{
		$tpl->assign(MAINCONTENT_HERE,"database error or program bug! please mail to whatismail@yahoo.com");
	}
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
}

if ($action == "edit")
{
	if ($passwordval==$diarypass) {
	$contentval = dbFilter($contentval);
	$result = selectOperation($diarydate,$diarydate,$num);
	if ($num>0)
	{
		$row = diary_fetch_object($result[1]);
		$row->content = $contentval;
		updateOperation($diarydate,$row->getRawData());
	}
	$y = (int)date("Y",$diarydate);
	$m = (int)date("m",$diarydate);
	$d = (int)date("d",$diarydate);
	goLocation($PHP_SELF."?gYear=$y&gMonth=$m&gDay=$d");
	}
	else {
	$tpl->assign(MAINCONTENT_HERE,"<p align=center>hahahahaha....password is incorrect.");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
	}
}

if ($action=="deleteform")
{
	$sql = "SELECT * FROM diary WHERE diarydate=$diarydate";
	$result = selectOperation($diarydate,$diarydate,$num);
	if ($num>0)
	{
		$row = diary_fetch_object($result[1]);
		$tpl->assign(DIARYDATE,$diarydate);
		$tpl->assign(INIT_CONTENT,stringFilter($row->content));
		$tpl->assign(DELETE_YEAR,date("Y",$row->diarydate));
		$tpl->assign(DELETE_MONTH, date("m",$row->diarydate));
		$tpl->assign(DELETE_DAY,date("d",$row->diarydate));
		$tpl->parse(MAINCONTENT_HERE,"DELETEFORM");
	}
	else
	{
		$tpl->assign(MAINCONTENT_HERE,"database error or program bug! please mail to whatismail@yahoo.com");
	}
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
}

if ($action == "delete")
{
	if ($passwordval==$diarypass) {
	$contentval = dbFilter($contentval);
	$sql = "DELETE FROM diary WHERE diarydate=$diarydate";
	$result = deleteOperation($diarydate);
	goLocation($PHP_SELF."?gYear=$y&gMonth=$m&gDay=$d");
	}
	else {
	$tpl->assign(MAINCONTENT_HERE,"<p align=center>hahahahaha....password is incorrect.");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
	}
}

if ($action=="writeform") {
	$tpl->assign(INIT_YEAR,date("Y",time()) );
	$tpl->parse(MAINCONTENT_HERE,"WRITEFORM");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
}
if ($action=="write") {
	if ($passwordval==$diarypass) {
		$wdate = mktime(0,0,0,$monthval,$dayval,$yearval);
		$wtime = time();
		$ip = getenv("REMOTE_ADDR");
		$raw_data = new DataType($wdate,$wtime,$contentval,$ip);
		insertOperation($wdate,$raw_data->getRawData());	
		$sql = "INSERT INTO diary VALUES ('','$wdate','$wtime','$contentval')";
		goLocation($PHP_SELF);
	}
	else {
	$tpl->assign(MAINCONTENT_HERE,"<p align=center>hahahahaha....password is incorrect.");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
	}
}
// ½.

$tpl->assign(EDIT_LINK," ");
// 켱 ⵵  ˾Ƴ  ޷ ΰ  Ѵ.

if ($gYear=="") {   // ⵵ Է  ˾Ƽ ̹޷.
	$ntime = time();
	$vyear = date("Y",$ntime);
	$vmonth = date("m",$ntime);
}
else {  // ⵵Է  Է ,޷.
	$vyear = $gYear;
	$vmonth = $gMonth;
}

$vyear = (int)$vyear;
$vmonth = (int)$vmonth;

$endday[0] = 31;
$endday[1] = 31; $endday[2] = 28; $endday[3] = 31; $endday[4] = 30; $endday[5] = 31; $endday[6] = 30;
$endday[7] = 31; $endday[8] = 31; $endday[9] = 30; $endday[10] = 31; $endday[11] = 30; $endday[12] = 31;

if (isYunChk($vyear)==1) $endday[2] = 29;


$starttimeval = mktime(0,0,0,$vmonth-1,1,$vyear);         //  .
$endtimeval = mktime(0,0,0,$vmonth-1,$endday[$vmonth-1],$vyear); //  .
$starttimeval2 = mktime(0,0,0,$vmonth,1,$vyear);                // .
$endtimeval2 = mktime(0,0,0,$vmonth,$endday[$vmonth],$vyear);  // .

//⼭ ޷ 
$sql = "SELECT * FROM diary WHERE ".$starttimeval."<=diarydate AND diarydate<=".$endtimeval2." ORDER BY diarydate";

$result = selectOperation($starttimeval,$endtimeval2,$num); 
$point = 1;
$printout = "";

for ($i=$starttimeval;$i<=$endtimeval;$i=$i+86400) {
$without = true;
if ($point<=$num) {  //  Ȱ
	$row = diary_fetch_object($result[$point]);
	if ($i==$row->diarydate) {  // ¥ !
		$dispy = (int)date("Y",$i);
		$dispm = (int)date("m",$i);
		$dispd = (int)date("d",$i);

		$tpl->assign(THIS_YEAR,$dispy);
		$tpl->assign(THIS_MONTH,$dispm);
		$tpl->assign(THIS_DAY,$dispd);
		if (($dispm == $vmonth-1)&&($dispd == (int)$gDay)) {  // ؾ  ¥...
			$printout = $row->content;
		}
		$point++;
		$tpl->parse(DAYS,".DAY_WITH_DATA");
		$without = false;
	}
}
if ($without) {  // ¥ ٸ ̳ ϱⰡ Ƿ ¥ .
		$tpl->assign(THIS_DAY,(int)date("d",$i));
		$tpl->parse(DAYS,".DAY_WITHOUT_DATA");
}
}
$tpl->assign(YEAR_STRING,date("Y",$starttimeval));
$tpl->assign(MONTH_STRING,(($vmonth-1)!=0)?($vmonth-1):(12));
$tpl->parse(MONTH_LIST,"MONTH");
$tpl->clear(DAYS);

for ($i=$starttimeval2;$i<=$endtimeval2;$i=$i+86400) {
$without = true;
if ($point<=$num) {  //  Ȱ
	$row = diary_fetch_object($result[$point]);
	if ($i==$row->diarydate) {  // ¥ !
		$dispy = (int)date("Y",$i);
		$dispm = (int)date("m",$i);
		$dispd = (int)date("d",$i);

		$tpl->assign(THIS_YEAR,$dispy);
		$tpl->assign(THIS_MONTH,$dispm);
		$tpl->assign(THIS_DAY,$dispd);
		if (($dispm == $vmonth)&&($dispd == (int)$gDay)) {  // ؾ  ¥...
			$printout = $row->content;
		}
		$point++;
		$tpl->parse(DAYS,".DAY_WITH_DATA");
		$without = false;
	}
}
if ($without) {  // ¥ ٸ ̳ ϱⰡ Ƿ ¥ .
		$tpl->assign(THIS_DAY,(int)date("d",$i));
		$tpl->parse(DAYS,".DAY_WITHOUT_DATA");
}
}
$tpl->assign(YEAR_STRING,"<br>".date("Y",$starttimeval2));
$tpl->assign(MONTH_STRING,$vmonth);
$tpl->parse(MONTH_LIST,".MONTH");

$prevtime = mktime(0,0,0,$vmonth-2,1,$vyear);
$nexttime = mktime(0,0,0,$vmonth+2,1,$vyear);
$tpl->assign(PREV_YEAR,date("Y",$prevtime));
$tpl->assign(PREV_MONTH,date("m",$prevtime));
$tpl->assign(NEXT_YEAR,date("Y",$nexttime));
$tpl->assign(NEXT_MONTH,date("m",$nexttime));

// ޷   .

$tpl->assign(NOW_YEAR,$dispy);
$tpl->assign(NOW_MONTH,$dispm);

$reply_date = "";
if ($printout=="") { // ¥    μ.
	$check = true;
	if ($num>0) {
		$row = diary_fetch_object($result[$num]);
		$vday = date("d",$row->diarydate);
		$tpl->assign(NOW_DAY,(int)$vday);
		$tpl->assign(DIARY_CONTENT,stringFilter($row->content));
		$check = false;

		//  ũ 
		$tpl->assign(DIARYDATE,$row->diarydate);
		$tpl->parse(EDIT_LINK,"VIEW_EDIT_LINK");
		$reply_date = $row->diarydate;
	}
	if ($check) { // Ͱ  . Ǵ ?
		$tpl->assign(NOW_YEAR,"");
		$tpl->assign(NOW_MONTH,"");
		$tpl->assign(NOW_DAY,"*");
		$tpl->assign(DIARY_CONTENT,"");
		$tpl->assign(REPLY_HERE,"");
	}
}
else {
	$tpl->assign(NOW_DAY,(int)$gDay);
	$tpl->assign(DIARY_CONTENT,stringFilter($printout));
	
	// ũ 
	$edit_diarytime = mktime(0,0,0,$dispm,(int)$gDay,$dispy);
	$tpl->assign(DIARYDATE,$edit_diarytime);
	$reply_date = $edit_diarytime;
	$tpl->parse(EDIT_LINK,"VIEW_EDIT_LINK");
}

if ($reply_date != "") //  .
{

	$sql = "SELECT ";
	$result = selectOperation($reply_date,$reply_date+36399,$reply_count,"reply");
	$tpl->assign(REPLY_ITEM,"");
	for ($i=1;$i<=$reply_count;$i++)
	{
		$row = reply_fetch_object($result[$i]);
		$tpl->assign(REPLY_KEY,$row->diarydate);
		$tpl->assign(REPLY_NAME,stringFilter($row->writer));
		$tpl->assign(REPLY_COMMENT,stringFilter($row->content));
		$tpl->assign(REPLY_DATE,date("Y-m-d H:i",$row->writetime));
		$tpl->parse(REPLY_ITEM,".VIEW_REPLY_ITEM");
	}
}

$ntime = time();
if (($starttimeval<=$ntime)&&($ntime<=$endtimeval2)) $tpl->assign(GO_TO_TODAY,"");
else $tpl->assign(GO_TO_TODAY,'<font size=1><a href="'.$PHP_SELF.'">|go to today..|</a></font>');

if (!$check)
{	
	//  ׳ ϱⰡ ־  쿡 ؼ  Ҽ 
	if ($enable_reply) $tpl->parse(REPLY_HERE,"VIEW_REPLY");
	else $tpl->assign(REPLY_HERE,"");
}

$tpl->parse(MAINCONTENT_HERE,"VIEW");
$tpl->parse(MAIN,"MAINTPL");
$tpl->FastPrint(MAIN);
?>
