<?
// diary by whatisid
// 2001.02.18 ϱ κ ߰ 
// 2001.03.11 mysql ƴ file  ۼ
// 2001.09.16 ȿ ϰ  

include("./class.FastTemplate.php");
include("./config.inc.php");

$maxsize=81920;

class DataType
{
	var $diarydate;
	var $writetime;
	var $content;
	var $ip;

function DataType($dd,$wt,$ct,$ia)
{
	$this->diarydate = $dd;
	$this->writetime = $wt;
	$this->content = $ct;
	$this->ip = $ia;	
}

function getRawData()
{
	$retval = $this->diarydate."|".$this->writetime."|".rawurlencode($this->content)."|".$this->ip;
	return $retval;
}
}

function getFilename($timestp,$create=true)
{
	$file_name = "./data/diary_".date("Ym",$timestp).".db";
	if ($create)
	{
		if (!file_exists($file_name)) 
		{
			$cf = fopen($file_name,"w");
			fclose($cf);
		}
	}
	return $file_name;
}

function getTempFilename($timestp,$create=true)
{
	$file_name = "./data/diary_".date("Ym",$timestp).".db.temp";
	if ($create)
	{
		if (!file_exists($file_name)) 
		{
			$cf = fopen($file_name,"w");
			fclose($cf);
		}
	}
	return $file_name;
}

function diary_fetch_object($str)
{
//	0=diarydate,1=writedate,2=content,3=ip
	$parse = explode("|",$str);
	$row = new DataType($parse[0],$parse[1],rawurldecode($parse[2]),$parse[3]);

	return $row;
}


function updateOperation($key,$values)
{
	//global $file_name;
	global $maxsize;

	//   tempfile 
		$file_name = getFilename($key);
		$temp_file_name = getTempFilename($key,false);
        $fp = fopen($file_name,"r");
        $wfp = fopen($temp_file_name,"w");
        flock($fp,LOCK_SH);
        flock($wfp,LOCK_EX);
        while (!feof($fp))
        {
                $raw_data = fgets($fp,$maxsize);
                fputs($wfp,$raw_data);
        }
        flock($wfp,LOCK_UN);
        fclose($wfp);
        flock($fp,LOCK_UN);
        fclose($fp);

	// $key شϴ   $values  
	$result = false;
	$fp = fopen($temp_file_name,"r");
	$wfp = fopen($file_name,"w");
	flock($fp,LOCK_SH);
	flock($wfp,LOCK_EX);
	while (!feof($fp))
	{
		$raw_data = fgets($fp,$maxsize);
		$parse = explode("|",$raw_data);
		if ($parse[0] != $key)
		{
			 fputs($wfp,$raw_data);
		}
		else
		{
			fputs($wfp,$values);
			$result = true;
		}
	}
        flock($wfp,LOCK_UN);
        fclose($wfp);
        flock($fp,LOCK_UN);
        fclose($fp);
return $result;
}

function deleteOperation($key)
{
	//global $file_name;
	global $maxsize;

	//   tempfile 
		$file_name = getFilename($key);
		$temp_file_name = getTempFilename($key,false);
        $fp = fopen($file_name,"r");
        $wfp = fopen($temp_file_name,"w");
        flock($fp,LOCK_SH);
        flock($wfp,LOCK_EX);
        while (!feof($fp))
        {
                $raw_data = fgets($fp,$maxsize);
                fputs($wfp,$raw_data);
        }
        flock($wfp,LOCK_UN);
        fclose($wfp);
        flock($fp,LOCK_UN);
        fclose($fp);

	// $key شϴ    Ϸ 
	$result = false;
	$fp = fopen($temp_file_name,"r");
	$wfp = fopen($file_name,"w");
	flock($fp,LOCK_SH);
	flock($wfp,LOCK_EX);
	while (!feof($fp))
	{
		$raw_data = fgets($fp,$maxsize);
		$parse = explode("|",$raw_data);
		if ($parse[0] != $key)
		{
			 fputs($wfp,$raw_data);
		}
		else $result = true;
	}
        flock($wfp,LOCK_UN);
        fclose($wfp);
        flock($fp,LOCK_UN);
        fclose($fp);
return $result;
}

function selectOperation($from_key,$to_key,&$selected_rows)
{
	//global $file_name;
	global $maxsize;

	$while_key = $to_key;
	$count=0;
	while ($from_key<=$while_key)
	{
		$file_name = getFilename($while_key);
		$fp = fopen($file_name,"r");
		while (!feof($fp))
		{
			$raw_data = fgets($fp,$maxsize);
			$parse = explode("|",$raw_data);
			if (($from_key<=$parse[0])&&($parse[0]<=$to_key))
			{
				$count++;
				$row[$count] = $raw_data;
			}
		}
		$while_key = mktime(0,0,0,date("m",$while_key)-1,1,date("Y",$while_key));
	}
	$selected_rows = $count;
	for ($i=1;$i<=$count;$i++)
	{
		$reverse_row[$count-$i+1] = $row[$i];
	}
	return $reverse_row;
}

function insertOperation($key,$values)
{
	global $file_name;
	global $maxsize;

	// write ϴ κ diarydate,writetime,content,ip
	//  file tempfile ̵
	$file_name = getFilename($key);
	$temp_file_name = getTempFilename($key,false);

	$fp = fopen($file_name,"r");
	$wfp = fopen($temp_file_name,"w");
	flock($fp,LOCK_SH);
	flock($wfp,LOCK_EX);
	while (!feof($fp))
	{
		$raw_data = fgets($fp,$maxsize);
		fputs($wfp,$raw_data);
	}
	flock($wfp,LOCK_UN);
	fclose($wfp);
	flock($fp,LOCK_UN);
	fclose($fp);

	// tempfile $values   dbfile 
	$fp = fopen($temp_file_name,"r");
	$wfp = fopen($file_name,"w");
	flock($fp,LOCK_SH);
	flock($wfp,LOCK_EX);
	$not_inserted = true;
	$rows_count = 0;
	while (true)
	{
		$raw_data = fgets($fp,$maxsize);
		if (feof($fp)&&($raw_data=="")) break;
		$parse = explode("|",$raw_data);
		// $key   ö  data tempfile ϰ,     tempfile $value .
		if ($parse[0]>$key) 
		{
			fputs($wfp,$raw_data);
			$row_count++;
		}
		if (($parse[0]<$key)&&($not_inserted))
		{
			fputs($wfp,$values."\n");
			$not_inserted = false;
			$row_count++;
		}
		if (($parse[0]<$key)&&(!$not_inserted))
		{
			fputs($wfp,$raw_data);
			$row_count++;
		}
	}
	if ($not_inserted) fputs($wfp,$values."\n");
	flock($wfp,LOCK_UN);
	fclose($wfp);
	flock($fp,LOCK_UN);
	fclose($fp);
}

function goLocation($location) { 
	echo("<meta http-equiv=\"refresh\" content=\"0;url=$location\">");
	exit();
}

function stringFilter($censorstr,$htmlallow=true) {
	$first = stripslashes(eregi_replace("<script>|</script>","&nbsp;",$censorstr));
	if (!$htmlallow) {
			$first = eregi_replace("<","&lt;",$first);
			$first = eregi_replace(">","&gt;",$first);
	}
//	if (trim($first)=="") $first = "";
	return nl2br(stripslashes(stripslashes($first)));
}

function dbFilter($censorstr) {
	return addslashes($censorstr);
}

function isYunChk($yearvalue) {
// 4   ̰ 100    ƴϰ 400   ̴.
// return 1 ̸ 
	$retval = 0;
	if (($yearvalue%4)==0) {
		$retval = 1;
		if (($yearvalue%100)==0) {
			$retval = 0;
			if (($yearvalue%400)==0) {
				$retval = 1;
			}
		}
	}

	return $retval;
}

$tpl = new FastTemplate("./tpl/");
$tpl->define(array(
	MAINTPL => "maintpl.tpl",
	EDITFORM => "editform.tpl",
	DELETEFORM => "deleteform.tpl",
	VIEW => "view.tpl",
	VIEW_EDIT_LINK => "view_edit_link.tpl",
	MONTH => "month.tpl",
	DAY_WITH_DATA => "day_with_data.tpl",
	DAY_WITHOUT_DATA => "day_without_data.tpl",
	WRITEFORM => "writeform.tpl"
	));

$tpl->assign(PHP_SELF,$PHP_SELF);
$nowtime = time();

if ($action=="editform")
{
	$sql = "SELECT * FROM diary WHERE diarydate=$diarydate";
	$result = selectOperation($diarydate,$diarydate,$num);
	if ($num>0)
	{
		$row = diary_fetch_object($result[1]);
		$tpl->assign(DIARYDATE,$diarydate);
		$tpl->assign(INIT_CONTENT,stripSlashes($row->content));
		$tpl->assign(EDIT_YEAR,date("Y",$row->diarydate));
		$tpl->assign(EDIT_MONTH, date("m",$row->diarydate));
		$tpl->assign(EDIT_DAY,date("d",$row->diarydate));
		$tpl->parse(MAINCONTENT_HERE,"EDITFORM");
	}
	else
	{
		$tpl->assign(MAINCONTENT_HERE,"database error or program bug! please mail to whatismail@yahoo.com");
	}
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
}

if ($action == "edit")
{
	if ($passwordval==$diarypass) {
	$contentval = dbFilter($contentval);
	$result = selectOperation($diarydate,$diarydate,$num);
	if ($num>0)
	{
		$row = diary_fetch_object($result[1]);
		$row->content = $contentval;
		updateOperation($diarydate,$row->getRawData());
	}
	$y = (int)date("Y",$diarydate);
	$m = (int)date("m",$diarydate);
	$d = (int)date("d",$diarydate);
	goLocation($PHP_SELF."?gYear=$y&gMonth=$m&gDay=$d");
	}
	else {
	$tpl->assign(MAINCONTENT_HERE,"<p align=center>hahahahaha....password is incorrect.");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
	}
}

if ($action=="deleteform")
{
	$sql = "SELECT * FROM diary WHERE diarydate=$diarydate";
	$result = selectOperation($diarydate,$diarydate,$num);
	if ($num>0)
	{
		$row = diary_fetch_object($result[1]);
		$tpl->assign(DIARYDATE,$diarydate);
		$tpl->assign(INIT_CONTENT,stringFilter($row->content));
		$tpl->assign(DELETE_YEAR,date("Y",$row->diarydate));
		$tpl->assign(DELETE_MONTH, date("m",$row->diarydate));
		$tpl->assign(DELETE_DAY,date("d",$row->diarydate));
		$tpl->parse(MAINCONTENT_HERE,"DELETEFORM");
	}
	else
	{
		$tpl->assign(MAINCONTENT_HERE,"database error or program bug! please mail to whatismail@yahoo.com");
	}
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
}

if ($action == "delete")
{
	if ($passwordval==$diarypass) {
	$contentval = dbFilter($contentval);
	$sql = "DELETE FROM diary WHERE diarydate=$diarydate";
	$result = deleteOperation($diarydate);
	goLocation($PHP_SELF."?gYear=$y&gMonth=$m&gDay=$d");
	}
	else {
	$tpl->assign(MAINCONTENT_HERE,"<p align=center>hahahahaha....password is incorrect.");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
	}
}

if ($action=="writeform") {
	$tpl->assign(INIT_YEAR,date("Y",time()) );
	$tpl->parse(MAINCONTENT_HERE,"WRITEFORM");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
}
if ($action=="write") {
	if ($passwordval==$diarypass) {
		$wdate = mktime(0,0,0,$monthval,$dayval,$yearval);
		$wtime = time();
		$ip = getenv("REMOTE_ADDR");
		$raw_data = new DataType($wdate,$wtime,$contentval,$ip);
		insertOperation($wdate,$raw_data->getRawData());	
		$sql = "INSERT INTO diary VALUES ('','$wdate','$wtime','$contentval')";
		goLocation($PHP_SELF);
	}
	else {
	$tpl->assign(MAINCONTENT_HERE,"<p align=center>hahahahaha....password is incorrect.");
	$tpl->parse(MAIN,"MAINTPL");
	$tpl->FastPrint(MAIN);
	exit();
	}
}
// ½.

$tpl->assign(EDIT_LINK," ");

// 켱 ⵵  ˾Ƴ  ޷ ΰ  Ѵ.

if ($gYear=="") {   // ⵵ Է  ˾Ƽ ̹޷.
	$ntime = time();
	$vyear = date("Y",$ntime);
	$vmonth = date("m",$ntime);
}
else {  // ⵵Է  Է ,޷.
	$vyear = $gYear;
	$vmonth = $gMonth;
}

$vyear = (int)$vyear;
$vmonth = (int)$vmonth;

$endday[0] = 31;
$endday[1] = 31; $endday[2] = 28; $endday[3] = 31; $endday[4] = 30; $endday[5] = 31; $endday[6] = 30;
$endday[7] = 31; $endday[8] = 31; $endday[9] = 30; $endday[10] = 31; $endday[11] = 30; $endday[12] = 31;

if (isYunChk($vyear)==1) $endday[2] = 29;


$starttimeval2 = mktime(0,0,0,$vmonth,1,$vyear);                // .
$endtimeval2 = mktime(0,0,0,$vmonth,$endday[$vmonth],$vyear);  // .

//⼭ ޷ 
$sql = "SELECT * FROM diary WHERE ".$starttimeval2."<=diarydate AND diarydate<=".$endtimeval2." ORDER BY diarydate";

$result = selectOperation($starttimeval2,$endtimeval2,$num); 
$point = 1;
$printout = "";

for ($i=$starttimeval2;$i<=$endtimeval2;$i=$i+86400) {
$without = true;
if ($point<=$num) {  //  Ȱ
	$row = diary_fetch_object($result[$point]);
	if ($i==$row->diarydate) {  // ¥ !
		$dispy = (int)date("Y",$i);
		$dispm = (int)date("m",$i);
		$dispd = (int)date("d",$i);

		$tpl->assign(THIS_YEAR,$dispy);
		$tpl->assign(THIS_MONTH,$dispm);
		$tpl->assign(THIS_DAY,$dispd);
		if (($dispm == $vmonth)&&($dispd == (int)$gDay)) {  // ؾ  ¥...
			$printout = $row->content;
		}
		$point++;
		$tpl->parse(DAYS,".DAY_WITH_DATA");
		$without = false;
	}
}
if ($without) {  // ¥ ٸ ̳ ϱⰡ Ƿ ¥ .
		$tpl->assign(THIS_DAY,(int)date("d",$i));
		$tpl->parse(DAYS,".DAY_WITHOUT_DATA");
}
}
$tpl->assign(YEAR_STRING,"<br>".date("Y",$starttimeval2));
$tpl->assign(MONTH_STRING,$vmonth);
$tpl->parse(MONTH_LIST,".MONTH");

$prevtime = mktime(0,0,0,$vmonth-1,1,$vyear);
$nexttime = mktime(0,0,0,$vmonth+1,1,$vyear);
$tpl->assign(PREV_YEAR,date("Y",$prevtime));
$tpl->assign(PREV_MONTH,date("m",$prevtime));
$tpl->assign(NEXT_YEAR,date("Y",$nexttime));
$tpl->assign(NEXT_MONTH,date("m",$nexttime));

// ޷   .

$tpl->assign(NOW_YEAR,$dispy);
$tpl->assign(NOW_MONTH,$dispm);

if ($printout=="") { // ¥    μ.
	$check = true;
	if ($num>0) {
		$row = diary_fetch_object($result[$num]);
		$vday = date("d",$row->diarydate);
		$tpl->assign(NOW_DAY,(int)$vday);
		$tpl->assign(DIARY_CONTENT,stringFilter($row->content));
		$check = false;

		//  ũ 
		$tpl->assign(DIARYDATE,$row->diarydate);
		$tpl->parse(EDIT_LINK,"VIEW_EDIT_LINK");
	}
	if ($check) { // Ͱ  . Ǵ ?
		$tpl->assign(NOW_YEAR,"");
		$tpl->assign(NOW_MONTH,"");
		$tpl->assign(NOW_DAY,"*");
		$tpl->assign(DIARY_CONTENT,"");
	}
}
else {
	$tpl->assign(NOW_DAY,(int)$gDay);
	$tpl->assign(DIARY_CONTENT,stringFilter($printout));
	
	// ũ 
	$edit_diarytime = mktime(0,0,0,$dispm,(int)$gDay,$dispy);
	$tpl->assign(DIARYDATE,$edit_diarytime);
	$tpl->parse(EDIT_LINK,"VIEW_EDIT_LINK");
}

$ntime = time();
if (($starttimeval2<=$ntime)&&($ntime<=$endtimeval2)) $tpl->assign(GO_TO_TODAY,"");
else $tpl->assign(GO_TO_TODAY,'<font size=1><a href="'.$PHP_SELF.'">|go to today..|</a></font>');


$tpl->parse(MAINCONTENT_HERE,"VIEW");
$tpl->parse(MAIN,"MAINTPL");
$tpl->FastPrint(MAIN);
?>
